/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         dmlparse
#define yylex           dmllex
#define yyerror         dmlerror
#define yydebug         dmldebug
#define yynerrs         dmlnerrs

/* First part of user prologue.  */

#include <string.h>
#include "dmlparser.h"

#undef DECIMAL
#undef DELETE
#undef IN
#ifdef _MSC_VER
#include "dml-gram-win.h"
#else
#include "dml-gram.h"
#endif

using namespace std;
using namespace dmlpackage;	

int dmllex(YYSTYPE* dmllval, void* yyscanner);

void dmlerror (void* yyscanner, char const *error);

namespace dmlpackage {

/* The user is expect to pass a ParseTree* to grammar_init */
static ParseTree* parseTree;
typedef std::vector<char*> copybuf_t;
static copybuf_t copy_buffer;
static std::string default_schema;
char* copy_string(const char *str);

}



# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "dml-gram.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_NAME = 3,                       /* NAME  */
  YYSYMBOL_STRING = 4,                     /* STRING  */
  YYSYMBOL_INTNUM = 5,                     /* INTNUM  */
  YYSYMBOL_APPROXNUM = 6,                  /* APPROXNUM  */
  YYSYMBOL_SELECT = 7,                     /* SELECT  */
  YYSYMBOL_ALL = 8,                        /* ALL  */
  YYSYMBOL_DISTINCT = 9,                   /* DISTINCT  */
  YYSYMBOL_NULLX = 10,                     /* NULLX  */
  YYSYMBOL_USER = 11,                      /* USER  */
  YYSYMBOL_INDICATOR = 12,                 /* INDICATOR  */
  YYSYMBOL_AMMSC = 13,                     /* AMMSC  */
  YYSYMBOL_PARAMETER = 14,                 /* PARAMETER  */
  YYSYMBOL_ANY = 15,                       /* ANY  */
  YYSYMBOL_SOME = 16,                      /* SOME  */
  YYSYMBOL_OR = 17,                        /* OR  */
  YYSYMBOL_AND = 18,                       /* AND  */
  YYSYMBOL_NOT = 19,                       /* NOT  */
  YYSYMBOL_COMPARISON = 20,                /* COMPARISON  */
  YYSYMBOL_21_ = 21,                       /* '+'  */
  YYSYMBOL_22_ = 22,                       /* '-'  */
  YYSYMBOL_23_ = 23,                       /* '*'  */
  YYSYMBOL_24_ = 24,                       /* '/'  */
  YYSYMBOL_UMINUS = 25,                    /* UMINUS  */
  YYSYMBOL_AS = 26,                        /* AS  */
  YYSYMBOL_ASC = 27,                       /* ASC  */
  YYSYMBOL_AUTHORIZATION = 28,             /* AUTHORIZATION  */
  YYSYMBOL_BETWEEN = 29,                   /* BETWEEN  */
  YYSYMBOL_BY = 30,                        /* BY  */
  YYSYMBOL_CHARACTER = 31,                 /* CHARACTER  */
  YYSYMBOL_CHECK = 32,                     /* CHECK  */
  YYSYMBOL_CLOSE = 33,                     /* CLOSE  */
  YYSYMBOL_COMMIT = 34,                    /* COMMIT  */
  YYSYMBOL_CONTINUE = 35,                  /* CONTINUE  */
  YYSYMBOL_CREATE = 36,                    /* CREATE  */
  YYSYMBOL_CURRENT = 37,                   /* CURRENT  */
  YYSYMBOL_CURSOR = 38,                    /* CURSOR  */
  YYSYMBOL_IDB_DECIMAL = 39,               /* IDB_DECIMAL  */
  YYSYMBOL_DECLARE = 40,                   /* DECLARE  */
  YYSYMBOL_DEFAULT = 41,                   /* DEFAULT  */
  YYSYMBOL_DELETE = 42,                    /* DELETE  */
  YYSYMBOL_DESC = 43,                      /* DESC  */
  YYSYMBOL_IDB_DOUBLE = 44,                /* IDB_DOUBLE  */
  YYSYMBOL_ESCAPE = 45,                    /* ESCAPE  */
  YYSYMBOL_EXISTS = 46,                    /* EXISTS  */
  YYSYMBOL_FETCH = 47,                     /* FETCH  */
  YYSYMBOL_IDB_FLOAT = 48,                 /* IDB_FLOAT  */
  YYSYMBOL_FOR = 49,                       /* FOR  */
  YYSYMBOL_FOREIGN = 50,                   /* FOREIGN  */
  YYSYMBOL_FOUND = 51,                     /* FOUND  */
  YYSYMBOL_FROM = 52,                      /* FROM  */
  YYSYMBOL_GOTO = 53,                      /* GOTO  */
  YYSYMBOL_GRANT = 54,                     /* GRANT  */
  YYSYMBOL_IDB_GROUP = 55,                 /* IDB_GROUP  */
  YYSYMBOL_HAVING = 56,                    /* HAVING  */
  YYSYMBOL_IN = 57,                        /* IN  */
  YYSYMBOL_INSERT = 58,                    /* INSERT  */
  YYSYMBOL_INTEGER = 59,                   /* INTEGER  */
  YYSYMBOL_INTO = 60,                      /* INTO  */
  YYSYMBOL_IS = 61,                        /* IS  */
  YYSYMBOL_KEY = 62,                       /* KEY  */
  YYSYMBOL_LANGUAGE = 63,                  /* LANGUAGE  */
  YYSYMBOL_LIKE = 64,                      /* LIKE  */
  YYSYMBOL_NUMERIC = 65,                   /* NUMERIC  */
  YYSYMBOL_OF = 66,                        /* OF  */
  YYSYMBOL_ON = 67,                        /* ON  */
  YYSYMBOL_OPEN = 68,                      /* OPEN  */
  YYSYMBOL_OPTION = 69,                    /* OPTION  */
  YYSYMBOL_ORDER = 70,                     /* ORDER  */
  YYSYMBOL_PRECISION = 71,                 /* PRECISION  */
  YYSYMBOL_PRIMARY = 72,                   /* PRIMARY  */
  YYSYMBOL_PRIVILEGES = 73,                /* PRIVILEGES  */
  YYSYMBOL_PROCEDURE = 74,                 /* PROCEDURE  */
  YYSYMBOL_PUBLIC = 75,                    /* PUBLIC  */
  YYSYMBOL_REAL = 76,                      /* REAL  */
  YYSYMBOL_REFERENCES = 77,                /* REFERENCES  */
  YYSYMBOL_ROLLBACK = 78,                  /* ROLLBACK  */
  YYSYMBOL_SCHEMA = 79,                    /* SCHEMA  */
  YYSYMBOL_SET = 80,                       /* SET  */
  YYSYMBOL_SMALLINT = 81,                  /* SMALLINT  */
  YYSYMBOL_SQLCODE = 82,                   /* SQLCODE  */
  YYSYMBOL_SQLERROR = 83,                  /* SQLERROR  */
  YYSYMBOL_TABLE = 84,                     /* TABLE  */
  YYSYMBOL_TO = 85,                        /* TO  */
  YYSYMBOL_UNION = 86,                     /* UNION  */
  YYSYMBOL_UNIQUE = 87,                    /* UNIQUE  */
  YYSYMBOL_UPDATE = 88,                    /* UPDATE  */
  YYSYMBOL_VALUES = 89,                    /* VALUES  */
  YYSYMBOL_VIEW = 90,                      /* VIEW  */
  YYSYMBOL_WHENEVER = 91,                  /* WHENEVER  */
  YYSYMBOL_WHERE = 92,                     /* WHERE  */
  YYSYMBOL_WITH = 93,                      /* WITH  */
  YYSYMBOL_WORK = 94,                      /* WORK  */
  YYSYMBOL_95_ = 95,                       /* ';'  */
  YYSYMBOL_96_ = 96,                       /* '('  */
  YYSYMBOL_97_ = 97,                       /* ')'  */
  YYSYMBOL_98_ = 98,                       /* ','  */
  YYSYMBOL_99_ = 99,                       /* '.'  */
  YYSYMBOL_YYACCEPT = 100,                 /* $accept  */
  YYSYMBOL_sql_list = 101,                 /* sql_list  */
  YYSYMBOL_sql = 102,                      /* sql  */
  YYSYMBOL_schema = 103,                   /* schema  */
  YYSYMBOL_opt_schema_element_list = 104,  /* opt_schema_element_list  */
  YYSYMBOL_schema_element_list = 105,      /* schema_element_list  */
  YYSYMBOL_schema_element = 106,           /* schema_element  */
  YYSYMBOL_base_table_def = 107,           /* base_table_def  */
  YYSYMBOL_base_table_element_commalist = 108, /* base_table_element_commalist  */
  YYSYMBOL_base_table_element = 109,       /* base_table_element  */
  YYSYMBOL_column_def = 110,               /* column_def  */
  YYSYMBOL_column_def_opt_list = 111,      /* column_def_opt_list  */
  YYSYMBOL_column_def_opt = 112,           /* column_def_opt  */
  YYSYMBOL_table_constraint_def = 113,     /* table_constraint_def  */
  YYSYMBOL_column_commalist = 114,         /* column_commalist  */
  YYSYMBOL_view_def = 115,                 /* view_def  */
  YYSYMBOL_opt_with_check_option = 116,    /* opt_with_check_option  */
  YYSYMBOL_opt_column_commalist = 117,     /* opt_column_commalist  */
  YYSYMBOL_privilege_def = 118,            /* privilege_def  */
  YYSYMBOL_opt_with_grant_option = 119,    /* opt_with_grant_option  */
  YYSYMBOL_privileges = 120,               /* privileges  */
  YYSYMBOL_operation_commalist = 121,      /* operation_commalist  */
  YYSYMBOL_operation = 122,                /* operation  */
  YYSYMBOL_grantee_commalist = 123,        /* grantee_commalist  */
  YYSYMBOL_grantee = 124,                  /* grantee  */
  YYSYMBOL_cursor_def = 125,               /* cursor_def  */
  YYSYMBOL_opt_order_by_clause = 126,      /* opt_order_by_clause  */
  YYSYMBOL_ordering_spec_commalist = 127,  /* ordering_spec_commalist  */
  YYSYMBOL_ordering_spec = 128,            /* ordering_spec  */
  YYSYMBOL_opt_asc_desc = 129,             /* opt_asc_desc  */
  YYSYMBOL_manipulative_statement = 130,   /* manipulative_statement  */
  YYSYMBOL_close_statement = 131,          /* close_statement  */
  YYSYMBOL_commit_statement = 132,         /* commit_statement  */
  YYSYMBOL_delete_statement_positioned = 133, /* delete_statement_positioned  */
  YYSYMBOL_delete_statement_searched = 134, /* delete_statement_searched  */
  YYSYMBOL_fetch_statement = 135,          /* fetch_statement  */
  YYSYMBOL_insert_statement = 136,         /* insert_statement  */
  YYSYMBOL_values_or_query_spec = 137,     /* values_or_query_spec  */
  YYSYMBOL_insert_atom_commalist = 138,    /* insert_atom_commalist  */
  YYSYMBOL_insert_atom = 139,              /* insert_atom  */
  YYSYMBOL_open_statement = 140,           /* open_statement  */
  YYSYMBOL_rollback_statement = 141,       /* rollback_statement  */
  YYSYMBOL_select_statement = 142,         /* select_statement  */
  YYSYMBOL_opt_all_distinct = 143,         /* opt_all_distinct  */
  YYSYMBOL_update_statement_positioned = 144, /* update_statement_positioned  */
  YYSYMBOL_assignment_commalist = 145,     /* assignment_commalist  */
  YYSYMBOL_assignment = 146,               /* assignment  */
  YYSYMBOL_update_statement_searched = 147, /* update_statement_searched  */
  YYSYMBOL_target_commalist = 148,         /* target_commalist  */
  YYSYMBOL_target = 149,                   /* target  */
  YYSYMBOL_opt_where_clause = 150,         /* opt_where_clause  */
  YYSYMBOL_query_exp = 151,                /* query_exp  */
  YYSYMBOL_query_term = 152,               /* query_term  */
  YYSYMBOL_query_spec = 153,               /* query_spec  */
  YYSYMBOL_selection = 154,                /* selection  */
  YYSYMBOL_table_exp = 155,                /* table_exp  */
  YYSYMBOL_from_clause = 156,              /* from_clause  */
  YYSYMBOL_table_ref_commalist = 157,      /* table_ref_commalist  */
  YYSYMBOL_table_ref = 158,                /* table_ref  */
  YYSYMBOL_where_clause = 159,             /* where_clause  */
  YYSYMBOL_opt_group_by_clause = 160,      /* opt_group_by_clause  */
  YYSYMBOL_column_ref_commalist = 161,     /* column_ref_commalist  */
  YYSYMBOL_opt_having_clause = 162,        /* opt_having_clause  */
  YYSYMBOL_search_condition = 163,         /* search_condition  */
  YYSYMBOL_predicate = 164,                /* predicate  */
  YYSYMBOL_comparison_predicate = 165,     /* comparison_predicate  */
  YYSYMBOL_between_predicate = 166,        /* between_predicate  */
  YYSYMBOL_like_predicate = 167,           /* like_predicate  */
  YYSYMBOL_opt_escape = 168,               /* opt_escape  */
  YYSYMBOL_test_for_null = 169,            /* test_for_null  */
  YYSYMBOL_in_predicate = 170,             /* in_predicate  */
  YYSYMBOL_atom_commalist = 171,           /* atom_commalist  */
  YYSYMBOL_all_or_any_predicate = 172,     /* all_or_any_predicate  */
  YYSYMBOL_any_all_some = 173,             /* any_all_some  */
  YYSYMBOL_existence_test = 174,           /* existence_test  */
  YYSYMBOL_subquery = 175,                 /* subquery  */
  YYSYMBOL_scalar_exp = 176,               /* scalar_exp  */
  YYSYMBOL_scalar_exp_commalist = 177,     /* scalar_exp_commalist  */
  YYSYMBOL_atom = 178,                     /* atom  */
  YYSYMBOL_parameter_ref = 179,            /* parameter_ref  */
  YYSYMBOL_function_ref = 180,             /* function_ref  */
  YYSYMBOL_literal = 181,                  /* literal  */
  YYSYMBOL_table = 182,                    /* table  */
  YYSYMBOL_table_name = 183,               /* table_name  */
  YYSYMBOL_column_ref = 184,               /* column_ref  */
  YYSYMBOL_data_type = 185,                /* data_type  */
  YYSYMBOL_column = 186,                   /* column  */
  YYSYMBOL_cursor = 187,                   /* cursor  */
  YYSYMBOL_parameter = 188,                /* parameter  */
  YYSYMBOL_range_variable = 189,           /* range_variable  */
  YYSYMBOL_user = 190,                     /* user  */
  YYSYMBOL_when_action = 191               /* when_action  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */





#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  47
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   523

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  100
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  92
/* YYNRULES -- Number of rules.  */
#define YYNRULES  221
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  415

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   345


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      96,    97,    23,    21,    98,    22,    99,    24,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    95,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   235,   235,   247,   258,   262,   265,   267,   271,   272,
     276,   277,   278,   282,   286,   287,   291,   292,   296,   299,
     301,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     317,   318,   319,   321,   323,   327,   332,   340,   344,   346,
     350,   351,   355,   359,   361,   365,   366,   367,   371,   372,
     376,   377,   378,   379,   380,   385,   386,   390,   391,   396,
     401,   404,   406,   410,   411,   415,   416,   419,   421,   422,
     427,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   445,   449,   453,   461,   469,   476,   480,   490,
     494,   501,   506,   514,   515,   519,   523,   527,   534,   540,
     541,   542,   546,   554,   559,   567,   571,   578,   585,   586,
     590,   594,   595,   601,   602,   603,   607,   608,   612,   624,
     625,   629,   643,   651,   656,   664,   665,   669,   677,   678,
     686,   691,   699,   700,   710,   717,   724,   730,   734,   743,
     747,   751,   755,   759,   763,   767,   774,   781,   791,   800,
     812,   820,   831,   832,   840,   846,   855,   862,   869,   877,
     888,   893,   901,   913,   914,   915,   919,   927,   941,   948,
     955,   962,   969,   975,   981,   982,   983,   984,   988,   994,
    1002,  1003,  1004,  1008,  1009,  1016,  1028,  1036,  1047,  1057,
    1068,  1069,  1070,  1076,  1080,  1081,  1092,  1093,  1100,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,  1122,  1123,  1124,
    1125,  1126,  1127,  1134,  1137,  1141,  1144,  1147,  1151,  1152,
    1155,  1156
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "NAME", "STRING",
  "INTNUM", "APPROXNUM", "SELECT", "ALL", "DISTINCT", "NULLX", "USER",
  "INDICATOR", "AMMSC", "PARAMETER", "ANY", "SOME", "OR", "AND", "NOT",
  "COMPARISON", "'+'", "'-'", "'*'", "'/'", "UMINUS", "AS", "ASC",
  "AUTHORIZATION", "BETWEEN", "BY", "CHARACTER", "CHECK", "CLOSE",
  "COMMIT", "CONTINUE", "CREATE", "CURRENT", "CURSOR", "IDB_DECIMAL",
  "DECLARE", "DEFAULT", "DELETE", "DESC", "IDB_DOUBLE", "ESCAPE", "EXISTS",
  "FETCH", "IDB_FLOAT", "FOR", "FOREIGN", "FOUND", "FROM", "GOTO", "GRANT",
  "IDB_GROUP", "HAVING", "IN", "INSERT", "INTEGER", "INTO", "IS", "KEY",
  "LANGUAGE", "LIKE", "NUMERIC", "OF", "ON", "OPEN", "OPTION", "ORDER",
  "PRECISION", "PRIMARY", "PRIVILEGES", "PROCEDURE", "PUBLIC", "REAL",
  "REFERENCES", "ROLLBACK", "SCHEMA", "SET", "SMALLINT", "SQLCODE",
  "SQLERROR", "TABLE", "TO", "UNION", "UNIQUE", "UPDATE", "VALUES", "VIEW",
  "WHENEVER", "WHERE", "WITH", "WORK", "';'", "'('", "')'", "','", "'.'",
  "$accept", "sql_list", "sql", "schema", "opt_schema_element_list",
  "schema_element_list", "schema_element", "base_table_def",
  "base_table_element_commalist", "base_table_element", "column_def",
  "column_def_opt_list", "column_def_opt", "table_constraint_def",
  "column_commalist", "view_def", "opt_with_check_option",
  "opt_column_commalist", "privilege_def", "opt_with_grant_option",
  "privileges", "operation_commalist", "operation", "grantee_commalist",
  "grantee", "cursor_def", "opt_order_by_clause",
  "ordering_spec_commalist", "ordering_spec", "opt_asc_desc",
  "manipulative_statement", "close_statement", "commit_statement",
  "delete_statement_positioned", "delete_statement_searched",
  "fetch_statement", "insert_statement", "values_or_query_spec",
  "insert_atom_commalist", "insert_atom", "open_statement",
  "rollback_statement", "select_statement", "opt_all_distinct",
  "update_statement_positioned", "assignment_commalist", "assignment",
  "update_statement_searched", "target_commalist", "target",
  "opt_where_clause", "query_exp", "query_term", "query_spec", "selection",
  "table_exp", "from_clause", "table_ref_commalist", "table_ref",
  "where_clause", "opt_group_by_clause", "column_ref_commalist",
  "opt_having_clause", "search_condition", "predicate",
  "comparison_predicate", "between_predicate", "like_predicate",
  "opt_escape", "test_for_null", "in_predicate", "atom_commalist",
  "all_or_any_predicate", "any_all_some", "existence_test", "subquery",
  "scalar_exp", "scalar_exp_commalist", "atom", "parameter_ref",
  "function_ref", "literal", "table", "table_name", "column_ref",
  "data_type", "column", "cursor", "parameter", "range_variable", "user",
  "when_action", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-270)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     352,   101,    20,   -63,   -25,    20,    30,    20,    90,    20,
      59,   185,    81,   337,   104,  -270,  -270,  -270,  -270,  -270,
    -270,  -270,  -270,  -270,  -270,  -270,  -270,  -270,  -270,  -270,
    -270,   286,  -270,  -270,  -270,   191,   202,   185,   156,   185,
    -270,  -270,   138,   162,  -270,   196,    -3,  -270,   154,  -270,
     168,  -270,  -270,  -270,  -270,   160,  -270,   320,   320,  -270,
     320,   192,   341,   172,  -270,  -270,  -270,  -270,  -270,   153,
     274,   232,   206,   269,   214,   299,   317,    -3,  -270,   324,
    -270,  -270,   340,    16,  -270,  -270,   135,   269,   320,   320,
     320,   320,   320,   269,  -270,  -270,    91,    21,   100,  -270,
    -270,   234,  -270,  -270,   317,    -1,  -270,  -270,    97,  -270,
     336,  -270,  -270,   261,   320,   366,   243,   149,  -270,    78,
     199,   199,  -270,  -270,   341,  -270,   127,    66,  -270,    91,
    -270,  -270,  -270,  -270,   101,    21,    82,  -270,  -270,   282,
     306,   295,   282,   213,  -270,  -270,  -270,  -270,  -270,  -270,
    -270,  -270,   326,   332,   269,   178,  -270,   300,  -270,  -270,
     222,   317,  -270,    73,   395,   161,   312,  -270,  -270,   185,
    -270,   311,   185,   185,  -270,   346,  -270,  -270,   214,   214,
     357,   316,  -270,  -270,   286,    50,   392,    33,  -270,  -270,
      20,   422,  -270,    26,   181,   282,   282,   157,   258,   320,
     335,   407,   122,  -270,  -270,   317,   347,   367,  -270,  -270,
     341,  -270,  -270,  -270,   344,  -270,   451,   282,   400,   360,
     214,  -270,  -270,  -270,   185,   121,   405,  -270,   175,    21,
    -270,  -270,   101,  -270,   440,  -270,   320,   363,   407,  -270,
    -270,  -270,   308,   295,  -270,   341,   414,    42,   415,  -270,
     452,  -270,  -270,   208,  -270,  -270,    20,   185,  -270,  -270,
     431,   408,    94,   437,   380,  -270,  -270,   150,   368,  -270,
     150,  -270,   286,   423,    42,   415,  -270,   320,   219,   371,
    -270,   407,  -270,  -270,  -270,   347,  -270,  -270,   366,   282,
    -270,   373,   409,   410,   374,   238,  -270,  -270,  -270,   358,
     460,    32,  -270,  -270,  -270,   175,  -270,   405,   320,   241,
     376,  -270,   341,  -270,   407,  -270,  -270,  -270,   377,  -270,
     213,   282,   378,   381,   317,  -270,    94,   382,   383,   411,
     384,  -270,   385,  -270,  -270,  -270,   390,  -270,   141,  -270,
    -270,  -270,   379,   341,  -270,  -270,  -270,   366,    52,   317,
     317,   270,  -270,   479,   480,  -270,   481,   482,   188,   456,
    -270,   435,    32,  -270,  -270,  -270,  -270,   303,   310,  -270,
     393,   329,   394,   351,   483,   396,   370,   185,  -270,   425,
     426,  -270,   419,  -270,  -270,  -270,   492,  -270,  -270,   493,
     -12,   282,  -270,  -270,  -270,   403,  -270,  -270,   185,   404,
     406,   438,  -270,    54,   317,   412,  -270,  -270,  -270,  -270,
     353,   317,  -270,   355,  -270
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    99,     0,    84,     0,     0,     0,     0,     0,     0,
      97,     0,     0,     0,     0,     4,    59,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,   100,
     101,     0,   214,    82,    83,     0,     0,     0,     0,     0,
      95,    96,   195,     0,   193,     0,     0,     1,     0,     2,
     196,   190,   191,   192,   182,     0,   215,     0,     0,   120,
       0,     0,   178,   119,   174,   180,   176,   181,   175,   183,
       0,     0,   111,     0,    40,     0,     0,     0,   221,     0,
     219,     3,     0,     0,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,   184,   217,     6,     0,     0,    86,
     112,    87,   108,   110,     0,     0,   194,   213,   111,   103,
       0,   218,   220,   197,     0,     0,     0,     0,   177,     0,
     168,   169,   170,   171,   179,   185,     0,     0,     5,     7,
       8,    10,    11,    12,    99,     0,    61,   113,   116,     0,
       0,     0,     0,   127,   138,   139,   140,   141,   142,   143,
     144,   145,     0,   175,     0,     0,    35,     0,    88,    90,
       0,     0,   107,     0,     0,     0,     0,   186,   189,     0,
      98,   111,     0,     0,    50,    46,    52,    51,    40,    40,
       0,    47,    48,     9,     0,     0,     0,     0,    60,   136,
       0,     0,   166,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   109,    41,     0,     0,     0,   104,   106,
     105,   198,   188,   187,   122,   123,   125,     0,   128,     0,
      40,    45,    54,    53,     0,     0,     0,   117,     0,     0,
     114,    85,    99,   137,   134,   135,     0,     0,     0,   164,
     163,   165,     0,     0,   147,   146,     0,     0,   152,   155,
       0,    36,    94,     0,    91,    93,     0,     0,   216,   126,
       0,   132,     0,     0,     0,    49,   118,    67,    62,    63,
      67,   115,     0,     0,     0,   152,   162,     0,     0,     0,
     160,     0,   151,   154,    89,     0,   102,   124,     0,     0,
     121,     0,     0,     0,     0,     0,    14,    16,    17,     0,
       0,     0,    68,    69,    65,     0,    66,     0,     0,     0,
       0,   150,   149,   159,     0,   157,   153,    92,   129,   130,
     133,     0,     0,     0,     0,    13,     0,   199,   204,     0,
     209,   207,   201,   211,   208,    19,    38,    57,    43,    55,
      58,    64,     0,   148,   158,   156,   161,     0,     0,     0,
       0,     0,    15,     0,     0,   212,     0,     0,    18,     0,
      37,     0,     0,    42,   167,   131,    34,     0,     0,    30,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,    56,     0,    31,   200,   205,     0,   210,   202,     0,
      21,     0,    25,    26,    24,    28,    39,    44,     0,     0,
       0,     0,    22,     0,     0,    32,   206,   203,    23,    27,
       0,     0,    29,     0,    33
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -270,  -270,   489,  -270,  -270,  -270,   375,  -270,  -270,   179,
    -270,  -270,  -270,  -270,  -269,  -270,  -270,  -163,  -270,  -270,
    -270,  -270,   281,  -270,   145,  -270,  -270,  -270,   204,   240,
    -270,  -270,  -270,  -270,  -270,  -270,  -270,  -270,  -270,   226,
    -270,  -270,  -270,  -131,  -270,  -270,   354,  -270,   427,   359,
     -56,   386,  -136,  -103,  -170,  -216,  -270,  -270,   255,  -270,
    -270,  -270,  -270,  -134,  -270,  -270,  -270,  -270,   242,  -270,
    -270,   244,  -270,  -270,  -270,     8,   -24,  -270,  -189,    61,
    -270,   140,   -11,   484,   -97,  -270,   -72,     4,    47,  -270,
     449,   443
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    13,    14,    15,   128,   129,   130,   131,   295,   296,
     297,   358,   378,   298,   155,   132,   360,   105,   133,   363,
     180,   181,   182,   338,   339,    16,   188,   268,   269,   304,
      17,    18,    19,    20,    21,    22,    23,   158,   253,   254,
      24,    25,    26,    31,    27,   108,   109,    28,   101,   102,
      99,   136,   137,   138,    61,   170,   171,   214,   215,   100,
     261,   318,   290,   143,   144,   145,   146,   147,   282,   148,
     149,   278,   150,   243,   151,   192,   152,    63,    64,    65,
      66,    67,   216,    44,    68,   335,   156,    33,    69,   259,
     340,    80
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      43,   153,   159,   184,   110,   189,   134,    62,   193,    36,
     266,    38,   248,    40,   226,   222,   223,   255,   166,    50,
      51,    52,    53,    32,   114,   115,    72,    54,   134,    55,
      56,    34,    78,    84,    85,    95,    86,    57,    58,   116,
     134,   229,   153,   195,   196,   153,    51,    52,    53,   275,
      79,   230,   162,    54,    35,   351,    56,   263,   280,   117,
     401,   234,   235,   153,   120,   121,   122,   123,   124,   195,
     196,   195,   196,   174,   175,   402,    50,    51,    52,    53,
     367,   368,    37,   209,    54,   280,    55,    56,   157,   110,
     165,   342,   316,   271,    57,    58,   255,   107,   153,   153,
      45,   272,   307,    50,    51,    52,    53,   337,   176,    29,
      30,    54,    60,    55,    56,   218,    94,   135,   194,   139,
     153,    57,    58,   233,   177,   346,   291,   126,   174,   135,
     169,   270,   249,   251,   103,   410,   187,   140,   191,   210,
     125,   250,   413,   178,   292,   127,   141,   227,   103,   366,
      39,   409,   186,    41,   179,   320,    88,    89,    90,    91,
      62,   219,   220,   176,    46,    93,   293,    56,   187,    60,
      88,    89,    90,    91,   245,   246,   154,   302,    50,   177,
     267,   294,    88,    89,    90,    91,   236,   348,    42,   160,
     299,   319,   153,   303,   231,   161,   142,   336,   178,    49,
     197,   198,    88,    89,    90,    91,   244,   374,   270,   179,
     199,   172,   273,   264,   237,   103,    73,   173,    86,    70,
     375,   238,    90,    91,   153,    50,    51,    52,    53,   376,
     195,   196,   118,    54,   361,    55,    56,    75,   200,   362,
      71,   139,    76,    57,    58,   201,   168,    77,    62,    81,
     365,   276,    87,   312,   299,   279,    83,   403,   212,   207,
     286,    50,    51,    52,    53,   377,   239,    82,   141,    54,
      92,    55,    56,   240,   241,   204,   205,    95,   118,    57,
      58,    97,   310,    56,   343,    50,    51,    52,    53,    50,
      51,    52,    53,    54,   153,    55,    56,    54,    98,    55,
      56,   139,   106,    57,    58,   284,   285,    57,    58,    59,
     104,    50,    51,    52,    53,   232,   313,   314,   142,    54,
     107,    55,    56,    50,    51,    52,    53,   112,   141,    57,
      58,    54,   154,    55,    56,   325,   326,    47,   344,   314,
     167,    57,    58,   113,     1,   197,   198,    88,    89,    90,
      91,    51,    52,    53,   242,   199,   163,   252,    54,     1,
     164,    56,    88,    89,    90,    91,   395,   369,   205,    50,
       2,     3,   190,     4,    51,    52,    53,     5,   142,     6,
     392,   393,    60,   200,     7,     2,     3,   405,     4,   327,
     201,   191,     5,   202,     6,     8,   206,   328,   211,     7,
     382,   205,   329,   217,    60,     9,   330,   383,   205,   213,
       8,    51,    52,    53,   225,    10,    60,   331,    54,   221,
       9,    56,   228,   332,   224,    11,   385,   386,    12,   232,
      10,   247,   277,   256,   333,    88,    89,    90,    91,   334,
      11,   308,   257,    12,    88,    89,    90,    91,   388,   389,
     412,   205,   414,   205,   258,   260,   262,   169,   196,   274,
     281,   288,   283,   300,   289,   301,   305,   134,   315,   321,
     324,   322,   323,   345,   349,   347,   364,   350,   353,   354,
     356,   357,   355,   359,   370,   371,   372,   373,   379,   380,
     384,   387,   391,   390,   396,   397,   398,   399,   400,   404,
     408,   406,    48,   407,   183,   352,   265,   381,   411,   341,
     306,   317,   287,   203,   119,   208,   394,   311,   309,    96,
     111,   185,     0,    74
};

static const yytype_int16 yycheck[] =
{
      11,    98,   105,   134,    76,   139,     7,    31,   142,     5,
     226,     7,   201,     9,   184,   178,   179,   206,   115,     3,
       4,     5,     6,     3,     8,     9,    37,    11,     7,    13,
      14,    94,    35,    57,    58,     3,    60,    21,    22,    23,
       7,     8,   139,    17,    18,   142,     4,     5,     6,   238,
      53,   187,   108,    11,    79,   324,    14,   220,   247,    83,
      72,   195,   196,   160,    88,    89,    90,    91,    92,    17,
      18,    17,    18,     7,     8,    87,     3,     4,     5,     6,
     349,   350,    52,    10,    11,   274,    13,    14,    89,   161,
     114,   307,   281,   229,    21,    22,   285,     3,   195,   196,
      19,   232,   272,     3,     4,     5,     6,    75,    42,     8,
       9,    11,    96,    13,    14,   171,    69,    96,   142,    19,
     217,    21,    22,    97,    58,   314,    32,    36,     7,    96,
      52,   228,    10,   205,    73,   404,    86,    37,    96,   163,
      93,    19,   411,    77,    50,    54,    46,    97,    87,    97,
      60,    97,    70,    94,    88,   289,    21,    22,    23,    24,
     184,   172,   173,    42,    83,    12,    72,    14,    86,    96,
      21,    22,    23,    24,   198,   199,    98,    27,     3,    58,
       5,    87,    21,    22,    23,    24,    29,   321,     3,    92,
     262,   288,   289,    43,   190,    98,    96,   300,    77,    95,
      19,    20,    21,    22,    23,    24,   198,    19,   305,    88,
      29,    84,   236,   224,    57,   154,    60,    90,   242,    28,
      32,    64,    23,    24,   321,     3,     4,     5,     6,    41,
      17,    18,    97,    11,    93,    13,    14,    99,    57,    98,
      38,    19,    80,    21,    22,    64,    97,    51,   272,    95,
     347,   243,    60,   277,   326,   247,    96,   391,    97,    37,
     256,     3,     4,     5,     6,    77,     8,    99,    46,    11,
      98,    13,    14,    15,    16,    97,    98,     3,    97,    21,
      22,    49,   274,    14,   308,     3,     4,     5,     6,     3,
       4,     5,     6,    11,   391,    13,    14,    11,    92,    13,
      14,    19,     3,    21,    22,    97,    98,    21,    22,    23,
      96,     3,     4,     5,     6,     7,    97,    98,    96,    11,
       3,    13,    14,     3,     4,     5,     6,     3,    46,    21,
      22,    11,    98,    13,    14,    97,    98,     0,    97,    98,
      97,    21,    22,     3,     7,    19,    20,    21,    22,    23,
      24,     4,     5,     6,    96,    29,    20,    10,    11,     7,
      99,    14,    21,    22,    23,    24,   377,    97,    98,     3,
      33,    34,    66,    36,     4,     5,     6,    40,    96,    42,
      10,    11,    96,    57,    47,    33,    34,   398,    36,    31,
      64,    96,    40,    61,    42,    58,    96,    39,     3,    47,
      97,    98,    44,    92,    96,    68,    48,    97,    98,    97,
      58,     4,     5,     6,    98,    78,    96,    59,    11,    73,
      68,    14,    30,    65,    67,    88,    97,    98,    91,     7,
      78,    96,    18,    66,    76,    21,    22,    23,    24,    81,
      88,    18,    98,    91,    21,    22,    23,    24,    97,    98,
      97,    98,    97,    98,     3,    55,    96,    52,    18,    96,
      45,    30,    10,    26,    56,    85,    98,     7,    97,    96,
      96,    62,    62,    97,    96,    98,    97,    96,    96,    96,
      96,    96,    71,    93,     5,     5,     5,     5,    32,    54,
      97,    97,    96,    10,    69,    69,    77,     5,     5,    96,
      62,    97,    13,    97,   129,   326,   225,   362,    96,   305,
     270,   285,   257,   154,    87,   161,   376,   275,   274,    70,
      77,   135,    -1,    39
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     7,    33,    34,    36,    40,    42,    47,    58,    68,
      78,    88,    91,   101,   102,   103,   125,   130,   131,   132,
     133,   134,   135,   136,   140,   141,   142,   144,   147,     8,
       9,   143,     3,   187,    94,    79,   187,    52,   187,    60,
     187,    94,     3,   182,   183,    19,    83,     0,   102,    95,
       3,     4,     5,     6,    11,    13,    14,    21,    22,    23,
      96,   154,   176,   177,   178,   179,   180,   181,   184,   188,
      28,    38,   182,    60,   183,    99,    80,    51,    35,    53,
     191,    95,    99,    96,   176,   176,   176,    60,    21,    22,
      23,    24,    98,    12,   188,     3,   190,    49,    92,   150,
     159,   148,   149,   179,    96,   117,     3,     3,   145,   146,
     186,   191,     3,     3,     8,     9,    23,   176,    97,   148,
     176,   176,   176,   176,   176,   188,    36,    54,   104,   105,
     106,   107,   115,   118,     7,    96,   151,   152,   153,    19,
      37,    46,    96,   163,   164,   165,   166,   167,   169,   170,
     172,   174,   176,   184,    98,   114,   186,    89,   137,   153,
      92,    98,   150,    20,    99,   176,   184,    97,    97,    52,
     155,   156,    84,    90,     7,     8,    42,    58,    77,    88,
     120,   121,   122,   106,   143,   151,    70,    86,   126,   163,
      66,    96,   175,   163,   176,    17,    18,    19,    20,    29,
      57,    64,    61,   149,    97,    98,    96,    37,   146,    10,
     176,     3,    97,    97,   157,   158,   182,    92,   150,   182,
     182,    73,   117,   117,    67,    98,   154,    97,    30,     8,
     152,   187,     7,    97,   163,   163,    29,    57,    64,     8,
      15,    16,    96,   173,   175,   176,   176,    96,   178,    10,
      19,   186,    10,   138,   139,   178,    66,    98,     3,   189,
      55,   160,    96,   117,   182,   122,   155,     5,   127,   128,
     184,   152,   143,   176,    96,   178,   175,    18,   171,   175,
     178,    45,   168,    10,    97,    98,   187,   158,    30,    56,
     162,    32,    50,    72,    87,   108,   109,   110,   113,   186,
      26,    85,    27,    43,   129,    98,   129,   154,    18,   171,
     175,   168,   176,    97,    98,    97,   178,   139,   161,   184,
     163,    96,    62,    62,    96,    97,    98,    31,    39,    44,
      48,    59,    65,    76,    81,   185,   153,    75,   123,   124,
     190,   128,   155,   176,    97,    97,   178,    98,   163,    96,
      96,   114,   109,    96,    96,    71,    96,    96,   111,    93,
     116,    93,    98,   119,    97,   184,    97,   114,   114,    97,
       5,     5,     5,     5,    19,    32,    41,    77,   112,    32,
      54,   124,    97,    97,    97,    97,    98,    97,    97,    98,
      10,    96,    10,    11,   181,   182,    69,    69,    77,     5,
       5,    72,    87,   163,    96,   182,    97,    97,    62,    97,
     114,    96,    97,   114,    97
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   100,   101,   101,   102,   103,   104,   104,   105,   105,
     106,   106,   106,   107,   108,   108,   109,   109,   110,   111,
     111,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     113,   113,   113,   113,   113,   114,   114,   115,   116,   116,
     117,   117,   118,   119,   119,   120,   120,   120,   121,   121,
     122,   122,   122,   122,   122,   123,   123,   124,   124,   102,
     125,   126,   126,   127,   127,   128,   128,   129,   129,   129,
     102,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   131,   132,   132,   133,   134,   135,   136,   137,
     137,   138,   138,   139,   139,   140,   141,   141,   142,   143,
     143,   143,   144,   145,   145,   146,   146,   147,   148,   148,
     149,   150,   150,   151,   151,   151,   152,   152,   153,   154,
     154,   155,   156,   157,   157,   158,   158,   159,   160,   160,
     161,   161,   162,   162,   163,   163,   163,   163,   163,   164,
     164,   164,   164,   164,   164,   164,   165,   165,   166,   166,
     167,   167,   168,   168,   169,   169,   170,   170,   170,   170,
     171,   171,   172,   173,   173,   173,   174,   175,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   177,   177,
     178,   178,   178,   179,   179,   179,   180,   180,   180,   180,
     181,   181,   181,   182,   183,   183,   184,   184,   184,   185,
     185,   185,   185,   185,   185,   185,   185,   185,   185,   185,
     185,   185,   185,   186,   187,   188,   189,   190,   102,   102,
     191,   191
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     3,     1,     5,     0,     1,     1,     2,
       1,     1,     1,     6,     1,     3,     1,     1,     3,     0,
       2,     2,     3,     4,     2,     2,     2,     4,     2,     5,
       4,     5,     7,    10,     4,     1,     3,     7,     0,     3,
       0,     3,     7,     0,     3,     2,     1,     1,     1,     3,
       1,     1,     1,     2,     2,     1,     3,     1,     1,     1,
       6,     0,     3,     1,     3,     2,     2,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     7,     4,     4,     5,     4,
       1,     1,     3,     1,     1,     2,     2,     1,     6,     0,
       1,     1,     8,     1,     3,     3,     3,     5,     1,     3,
       1,     0,     1,     1,     3,     4,     1,     3,     4,     1,
       1,     4,     2,     1,     3,     1,     2,     2,     0,     3,
       1,     3,     0,     2,     3,     3,     2,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     6,     5,
       5,     4,     0,     2,     4,     3,     6,     5,     6,     5,
       1,     3,     4,     1,     1,     1,     2,     6,     3,     3,
       3,     3,     2,     2,     1,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     2,     3,     4,     5,     5,     4,
       1,     1,     1,     1,     3,     1,     1,     3,     5,     1,
       4,     1,     4,     6,     1,     4,     6,     1,     1,     1,
       4,     1,     2,     1,     1,     1,     1,     1,     4,     3,
       2,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (scanner, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, scanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, void * scanner)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (scanner);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, void * scanner)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, scanner);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, void * scanner)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], scanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, scanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, void * scanner)
{
  YY_USE (yyvaluep);
  YY_USE (scanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (void * scanner)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, scanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* sql_list: sql ';'  */
                        {
 					if ((yyvsp[-1].sqlStmt) != NULL)
					{
						(yyval.sqlStmtList) = parseTree;
						(yyval.sqlStmtList)->push_back((yyvsp[-1].sqlStmt));
					}
					else
					{
						(yyval.sqlStmtList) = NULL;
					}
					
				}
    break;

  case 3: /* sql_list: sql_list sql ';'  */
                                   {
 							  
							    if ((yyvsp[-2].sqlStmtList) != NULL)
								{
									parseTree = (yyvsp[-2].sqlStmtList);
								}
								
							}
    break;

  case 4: /* sql: schema  */
                       { (yyval.sqlStmt) = NULL; }
    break;

  case 35: /* column_commalist: column  */
                {
		    (yyval.colNameList) = new ColumnNameList;
		    (yyval.colNameList)->push_back((yyvsp[0].strval));
		}
    break;

  case 36: /* column_commalist: column_commalist ',' column  */
                {
			(yyval.colNameList) = (yyvsp[-2].colNameList);
			(yyval.colNameList)->push_back((yyvsp[0].strval));
		}
    break;

  case 40: /* opt_column_commalist: %empty  */
                            { (yyval.colNameList) = NULL; }
    break;

  case 41: /* opt_column_commalist: '(' column_commalist ')'  */
                                         {(yyval.colNameList) = (yyvsp[-1].colNameList);}
    break;

  case 59: /* sql: cursor_def  */
                           { (yyval.sqlStmt) = NULL;  }
    break;

  case 82: /* close_statement: CLOSE cursor  */
                             { }
    break;

  case 83: /* commit_statement: COMMIT WORK  */
                {
			(yyval.sqlStmt) = new CommandSqlStatement("COMMIT");
		}
    break;

  case 84: /* commit_statement: COMMIT  */
                {
			(yyval.sqlStmt) = new CommandSqlStatement("COMMIT");
		}
    break;

  case 85: /* delete_statement_positioned: DELETE FROM table WHERE CURRENT OF cursor  */
                {
			(yyval.sqlStmt) = new DeleteSqlStatement((yyvsp[-4].tblName));
		       
		}
    break;

  case 86: /* delete_statement_searched: DELETE FROM table opt_where_clause  */
                {
			(yyval.sqlStmt) = new DeleteSqlStatement((yyvsp[-1].tblName),(yyvsp[0].whereClause));	
		}
    break;

  case 87: /* fetch_statement: FETCH cursor INTO target_commalist  */
                                                   { }
    break;

  case 88: /* insert_statement: INSERT INTO table_name opt_column_commalist values_or_query_spec  */
                {
			if (NULL == (yyvsp[-1].colNameList))
				(yyval.sqlStmt) = new InsertSqlStatement((yyvsp[-2].tblName), (yyvsp[0].valsOrQuery));
			else
				(yyval.sqlStmt) = new InsertSqlStatement((yyvsp[-2].tblName), (yyvsp[-1].colNameList), (yyvsp[0].valsOrQuery));
		}
    break;

  case 89: /* values_or_query_spec: VALUES '(' insert_atom_commalist ')'  */
                {
			(yyval.valsOrQuery) = new ValuesOrQuery((yyvsp[-1].valsList));
		}
    break;

  case 90: /* values_or_query_spec: query_spec  */
                {
			(yyval.valsOrQuery) = new ValuesOrQuery((yyvsp[0].querySpec));
		}
    break;

  case 91: /* insert_atom_commalist: insert_atom  */
                {
			(yyval.valsList) = new ValuesList;
			(yyval.valsList)->push_back((yyvsp[0].strval));
		}
    break;

  case 92: /* insert_atom_commalist: insert_atom_commalist ',' insert_atom  */
                {
			(yyval.valsList) = (yyvsp[-2].valsList);
			(yyval.valsList)->push_back((yyvsp[0].strval));
		}
    break;

  case 95: /* open_statement: OPEN cursor  */
                            { }
    break;

  case 96: /* rollback_statement: ROLLBACK WORK  */
                {
			(yyval.sqlStmt) = new CommandSqlStatement("ROLLBACK");
		}
    break;

  case 97: /* rollback_statement: ROLLBACK  */
                {
			(yyval.sqlStmt) = new CommandSqlStatement("ROLLBACK");
		}
    break;

  case 98: /* select_statement: SELECT opt_all_distinct selection INTO target_commalist table_exp  */
                          { }
    break;

  case 99: /* opt_all_distinct: %empty  */
                            { (yyval.strval) = NULL; }
    break;

  case 100: /* opt_all_distinct: ALL  */
                            { (yyval.strval) = (yyvsp[0].strval); }
    break;

  case 101: /* opt_all_distinct: DISTINCT  */
                            { (yyval.strval) = (yyvsp[0].strval); }
    break;

  case 102: /* update_statement_positioned: UPDATE table SET assignment_commalist WHERE CURRENT OF cursor  */
                {
	            (yyval.sqlStmt) = new UpdateSqlStatement((yyvsp[-6].tblName),(yyvsp[-4].colAssignmentList));
		}
    break;

  case 103: /* assignment_commalist: assignment  */
                {
		   (yyval.colAssignmentList) = new ColumnAssignmentList();
		   (yyval.colAssignmentList)->push_back((yyvsp[0].colAssignment));
		}
    break;

  case 104: /* assignment_commalist: assignment_commalist ',' assignment  */
                {
		   (yyval.colAssignmentList) = (yyvsp[-2].colAssignmentList);
		   (yyval.colAssignmentList)->push_back((yyvsp[0].colAssignment));
		}
    break;

  case 105: /* assignment: column COMPARISON scalar_exp  */
                {
		   (yyval.colAssignment) = new ColumnAssignment((yyvsp[-2].strval), (yyvsp[-1].strval), (yyvsp[0].strval));
		}
    break;

  case 106: /* assignment: column COMPARISON NULLX  */
                {
		   (yyval.colAssignment) = new ColumnAssignment((yyvsp[-2].strval), (yyvsp[-1].strval), (yyvsp[0].strval));
		}
    break;

  case 107: /* update_statement_searched: UPDATE table SET assignment_commalist opt_where_clause  */
                {
		   (yyval.sqlStmt) = new UpdateSqlStatement((yyvsp[-3].tblName), (yyvsp[-1].colAssignmentList), (yyvsp[0].whereClause));
		}
    break;

  case 111: /* opt_where_clause: %empty  */
                            { (yyval.whereClause) = NULL; }
    break;

  case 112: /* opt_where_clause: where_clause  */
                             { (yyval.whereClause) = (yyvsp[0].whereClause); }
    break;

  case 118: /* query_spec: SELECT opt_all_distinct selection table_exp  */
         {
                (yyval.querySpec) = new QuerySpec();
		if (NULL != (yyvsp[-2].strval))
		   (yyval.querySpec)->fOptionAllOrDistinct = (yyvsp[-2].strval); 
		(yyval.querySpec)->fSelectFilterPtr = (yyvsp[-1].selectFilter);
		(yyval.querySpec)->fTableExpressionPtr = (yyvsp[0].tableExpression);
                  		
	 }
    break;

  case 119: /* selection: scalar_exp_commalist  */
                                     { (yyval.selectFilter) = new SelectFilter((yyvsp[0].colNameList)); }
    break;

  case 120: /* selection: '*'  */
                    { (yyval.selectFilter) = new SelectFilter(); }
    break;

  case 121: /* table_exp: from_clause opt_where_clause opt_group_by_clause opt_having_clause  */
                {
		   (yyval.tableExpression) = new TableExpression();
		   (yyval.tableExpression)->fFromClausePtr = (yyvsp[-3].fromClause);
		   (yyval.tableExpression)->fWhereClausePtr = (yyvsp[-2].whereClause);
		   (yyval.tableExpression)->fGroupByPtr = (yyvsp[-1].groupByClause);
		   (yyval.tableExpression)->fHavingPtr  = (yyvsp[0].havingClause);
		}
    break;

  case 122: /* from_clause: FROM table_ref_commalist  */
                {
		   (yyval.fromClause) = new FromClause();
		   (yyval.fromClause)->fTableListPtr = (yyvsp[0].tableNameList);
		}
    break;

  case 123: /* table_ref_commalist: table_ref  */
                {
	           (yyval.tableNameList) = new TableNameList();
		   (yyval.tableNameList)->push_back((yyvsp[0].tblName));
		}
    break;

  case 124: /* table_ref_commalist: table_ref_commalist ',' table_ref  */
                {
		   (yyval.tableNameList) = (yyvsp[-2].tableNameList);
		   (yyval.tableNameList)->push_back((yyvsp[0].tblName));
		}
    break;

  case 127: /* where_clause: WHERE search_condition  */
                {
		   (yyval.whereClause) = new WhereClause();
		   (yyval.whereClause)->fSearchConditionPtr = (yyvsp[0].searchCondition);
		}
    break;

  case 128: /* opt_group_by_clause: %empty  */
                            { (yyval.groupByClause) = NULL; }
    break;

  case 129: /* opt_group_by_clause: IDB_GROUP BY column_ref_commalist  */
                {
		    (yyval.groupByClause) = new GroupByClause();
		    (yyval.groupByClause)->fColumnNamesListPtr = (yyvsp[0].colNameList);	
		}
    break;

  case 130: /* column_ref_commalist: column_ref  */
                {
		    (yyval.colNameList) = new ColumnNameList();
		    (yyval.colNameList)->push_back((yyvsp[0].strval));	
		}
    break;

  case 131: /* column_ref_commalist: column_ref_commalist ',' column_ref  */
                {
		    (yyval.colNameList) = (yyvsp[-2].colNameList);
		    (yyval.colNameList)->push_back((yyvsp[0].strval));	
		}
    break;

  case 132: /* opt_having_clause: %empty  */
                            { (yyval.havingClause) = NULL; }
    break;

  case 133: /* opt_having_clause: HAVING search_condition  */
                {
		   (yyval.havingClause) = new HavingClause();
		   (yyval.havingClause)->fSearchConditionPtr =  (yyvsp[0].searchCondition);		 
		}
    break;

  case 134: /* search_condition: search_condition OR search_condition  */
                {
		   (yyval.searchCondition) = new SearchCondition;
		   (yyval.searchCondition)->fLHSearchConditionPtr = (yyvsp[-2].searchCondition);
		   (yyval.searchCondition)->fOperator = "OR";
		   (yyval.searchCondition)->fRHSearchConditionPtr = (yyvsp[0].searchCondition);
		}
    break;

  case 135: /* search_condition: search_condition AND search_condition  */
                {
		   (yyval.searchCondition) = new SearchCondition;
		   (yyval.searchCondition)->fLHSearchConditionPtr = (yyvsp[-2].searchCondition);
		   (yyval.searchCondition)->fOperator = "AND";
		   (yyval.searchCondition)->fRHSearchConditionPtr = (yyvsp[0].searchCondition);
		}
    break;

  case 136: /* search_condition: NOT search_condition  */
                {
		   (yyval.searchCondition) = new SearchCondition;
		   (yyval.searchCondition)->fOperator = "NOT";	
		   (yyval.searchCondition)->fRHSearchConditionPtr = (yyvsp[0].searchCondition);
		}
    break;

  case 137: /* search_condition: '(' search_condition ')'  */
                {
		   (yyval.searchCondition) = new SearchCondition;
	      	}
    break;

  case 138: /* search_condition: predicate  */
                {
                  
		   (yyval.searchCondition) = new SearchCondition;
		   (yyval.searchCondition)->fPredicatePtr = (yyvsp[0].predicate);		    
		}
    break;

  case 139: /* predicate: comparison_predicate  */
                {
		   (yyval.predicate) = (yyvsp[0].comparisonPredicate);
		}
    break;

  case 140: /* predicate: between_predicate  */
                {
		   (yyval.predicate) = (yyvsp[0].betweenPredicate);	
		}
    break;

  case 141: /* predicate: like_predicate  */
                {
		   (yyval.predicate) = (yyvsp[0].likePredicate);
		}
    break;

  case 142: /* predicate: test_for_null  */
                {
		  (yyval.predicate) = (yyvsp[0].nullTestPredicate);
		}
    break;

  case 143: /* predicate: in_predicate  */
                {
		  (yyval.predicate) = (yyvsp[0].inPredicate);	
		}
    break;

  case 144: /* predicate: all_or_any_predicate  */
                {
		   (yyval.predicate) = (yyvsp[0].allOrAnyPredicate);
		}
    break;

  case 145: /* predicate: existence_test  */
                {
		   (yyval.predicate) = (yyvsp[0].existPredicate);
		}
    break;

  case 146: /* comparison_predicate: scalar_exp COMPARISON scalar_exp  */
                {
		   (yyval.comparisonPredicate) = new ComparisonPredicate();
		   (yyval.comparisonPredicate)->fLHScalarExpression = (yyvsp[-2].strval);
		   (yyval.comparisonPredicate)->fOperator = (yyvsp[-1].strval);
	       (yyval.comparisonPredicate)->fRHScalarExpression = (yyvsp[0].strval);
		}
    break;

  case 147: /* comparison_predicate: scalar_exp COMPARISON subquery  */
                {
		   (yyval.comparisonPredicate) = new ComparisonPredicate();
		   (yyval.comparisonPredicate)->fLHScalarExpression = (yyvsp[-2].strval);
		   (yyval.comparisonPredicate)->fOperator = (yyvsp[-1].strval);
		   (yyval.comparisonPredicate)->fSubQuerySpec = (yyvsp[0].querySpec);
		}
    break;

  case 148: /* between_predicate: scalar_exp NOT BETWEEN scalar_exp AND scalar_exp  */
                {
		   (yyval.betweenPredicate) = new BetweenPredicate();
		   (yyval.betweenPredicate)->fLHScalarExpression = (yyvsp[-5].strval);
		   (yyval.betweenPredicate)->fOperator1 = "NOT BETWEEN";
		   (yyval.betweenPredicate)->fRH1ScalarExpression = (yyvsp[-2].strval);
		   (yyval.betweenPredicate)->fOperator2 = "AND";
		   (yyval.betweenPredicate)->fRH2ScalarExpression = (yyvsp[0].strval);
		}
    break;

  case 149: /* between_predicate: scalar_exp BETWEEN scalar_exp AND scalar_exp  */
                {
		   (yyval.betweenPredicate) = new BetweenPredicate();
		   (yyval.betweenPredicate)->fLHScalarExpression = (yyvsp[-4].strval);
		   (yyval.betweenPredicate)->fOperator1 = "BETWEEN";
		   (yyval.betweenPredicate)->fRH1ScalarExpression = (yyvsp[-2].strval);
           (yyval.betweenPredicate)->fOperator2 = "AND";
           (yyval.betweenPredicate)->fRH2ScalarExpression = (yyvsp[0].strval);
		}
    break;

  case 150: /* like_predicate: scalar_exp NOT LIKE atom opt_escape  */
                {
		   (yyval.likePredicate) = new LikePredicate();
		   (yyval.likePredicate)->fLHScalarExpression = (yyvsp[-4].strval);
		   (yyval.likePredicate)->fOperator = "NOT LIKE";
		   (yyval.likePredicate)->fAtom = (yyvsp[-1].strval);
		   (yyval.likePredicate)->fOptionalEscapePtr = (yyvsp[0].escape);	
		}
    break;

  case 151: /* like_predicate: scalar_exp LIKE atom opt_escape  */
                {
		   (yyval.likePredicate) = new LikePredicate();
		   (yyval.likePredicate)->fLHScalarExpression = (yyvsp[-3].strval);
		   (yyval.likePredicate)->fOperator = "LIKE";
		   (yyval.likePredicate)->fAtom = (yyvsp[-1].strval);
		   (yyval.likePredicate)->fOptionalEscapePtr  = (yyvsp[0].escape); 	
		}
    break;

  case 152: /* opt_escape: %empty  */
                    { (yyval.escape) = NULL; }
    break;

  case 153: /* opt_escape: ESCAPE atom  */
                {
		   (yyval.escape) = new Escape();
		   (yyval.escape)->fEscapeChar = (yyvsp[0].strval);
		}
    break;

  case 154: /* test_for_null: column_ref IS NOT NULLX  */
                {
		   (yyval.nullTestPredicate) = new NullTestPredicate();
		   (yyval.nullTestPredicate)->fOperator = "IS NOT NULL";
		   (yyval.nullTestPredicate)->fColumnRef = (yyvsp[-3].strval);	 
		}
    break;

  case 155: /* test_for_null: column_ref IS NULLX  */
                {
		   (yyval.nullTestPredicate) = new NullTestPredicate();
		   (yyval.nullTestPredicate)->fOperator = "IS NULL";
		   (yyval.nullTestPredicate)->fColumnRef = (yyvsp[-2].strval);
		}
    break;

  case 156: /* in_predicate: scalar_exp NOT IN '(' subquery ')'  */
                {
		   (yyval.inPredicate) = new InPredicate();
		   (yyval.inPredicate)->fScalarExpression = (yyvsp[-5].strval);
	       (yyval.inPredicate)->fOperator = "NOT IN";
		   (yyval.inPredicate)->fSubQuerySpecPtr = (yyvsp[-1].querySpec);			
		}
    break;

  case 157: /* in_predicate: scalar_exp IN '(' subquery ')'  */
                {
		   (yyval.inPredicate) = new InPredicate();
		   (yyval.inPredicate)->fScalarExpression = (yyvsp[-4].strval);
		   (yyval.inPredicate)->fOperator = "IN";
		   (yyval.inPredicate)->fSubQuerySpecPtr = (yyvsp[-1].querySpec);
		}
    break;

  case 158: /* in_predicate: scalar_exp NOT IN '(' atom_commalist ')'  */
                {
		   (yyval.inPredicate) = new InPredicate();
		   (yyval.inPredicate)->fScalarExpression = (yyvsp[-5].strval);
		   (yyval.inPredicate)->fOperator = "NOT IN";
		   (yyval.inPredicate)->fAtomList = *(yyvsp[-1].atomList);	
		   delete (yyvsp[-1].atomList);
		}
    break;

  case 159: /* in_predicate: scalar_exp IN '(' atom_commalist ')'  */
                {
		   (yyval.inPredicate) = new InPredicate();
		   (yyval.inPredicate)->fScalarExpression = (yyvsp[-4].strval);
		   (yyval.inPredicate)->fOperator = "IN";
		   (yyval.inPredicate)->fAtomList = *(yyvsp[-1].atomList);
		   delete (yyvsp[-1].atomList);
		}
    break;

  case 160: /* atom_commalist: atom  */
                {
		    (yyval.atomList) = new AtomList();
	        (yyval.atomList)->push_back((yyvsp[0].strval));		 	
		}
    break;

  case 161: /* atom_commalist: atom_commalist ',' atom  */
                {
		    (yyval.atomList) = (yyvsp[-2].atomList);
		    (yyval.atomList)->push_back((yyvsp[0].strval)); 	
		}
    break;

  case 162: /* all_or_any_predicate: scalar_exp COMPARISON any_all_some subquery  */
                {
		   (yyval.allOrAnyPredicate) = new AllOrAnyPredicate();
		   (yyval.allOrAnyPredicate)->fScalarExpression = (yyvsp[-3].strval);
		   (yyval.allOrAnyPredicate)->fOperator = (yyvsp[-2].strval);
		   (yyval.allOrAnyPredicate)->fAnyAllSome = (yyvsp[-1].strval);
		   (yyval.allOrAnyPredicate)->fSubQuerySpecPtr = (yyvsp[0].querySpec);
			
		}
    break;

  case 166: /* existence_test: EXISTS subquery  */
                {
		   (yyval.existPredicate) = new ExistanceTestPredicate();
		   (yyval.existPredicate)->fSubQuerySpecPtr = (yyvsp[0].querySpec);
		}
    break;

  case 167: /* subquery: '(' SELECT opt_all_distinct selection table_exp ')'  */
                 {
		      (yyval.querySpec) = new QuerySpec();
		      if (NULL != (yyvsp[-3].strval))
			      (yyval.querySpec)->fOptionAllOrDistinct = (yyvsp[-3].strval);
		      (yyval.querySpec)->fSelectFilterPtr = (yyvsp[-2].selectFilter);
		      (yyval.querySpec)->fTableExpressionPtr = (yyvsp[-1].tableExpression);
		 }
    break;

  case 168: /* scalar_exp: scalar_exp '+' scalar_exp  */
                {
	       std::string str = (yyvsp[-2].strval);	
		   str +=  " + ";
		   str +=  (yyvsp[0].strval);
		   (yyval.strval) = copy_string(str.c_str());
		}
    break;

  case 169: /* scalar_exp: scalar_exp '-' scalar_exp  */
                {
		   std::string str =  (yyvsp[-2].strval);
		   str +=  " - ";
 	       str +=  (yyvsp[0].strval);
		   (yyval.strval) = copy_string(str.c_str()); 	
		}
    break;

  case 170: /* scalar_exp: scalar_exp '*' scalar_exp  */
                {
		   std::string str = (yyvsp[-2].strval);
	       str += " * ";
		   str += (yyvsp[0].strval);
		   (yyval.strval) = copy_string(str.c_str());	
		}
    break;

  case 171: /* scalar_exp: scalar_exp '/' scalar_exp  */
                {
		   std::string str = (yyvsp[-2].strval);
		   str += " / ";
		   str += (yyvsp[0].strval);
		   (yyval.strval) = copy_string(str.c_str()); 	
		}
    break;

  case 172: /* scalar_exp: '+' scalar_exp  */
                { 
		   std::string str = "+ ";
		   str += (yyvsp[0].strval);
 	       (yyval.strval) = copy_string(str.c_str());
	    }
    break;

  case 173: /* scalar_exp: '-' scalar_exp  */
                {
		   std::string str = "- ";
		   str += (yyvsp[0].strval);
		   (yyval.strval) = copy_string(str.c_str()); 		
		}
    break;

  case 177: /* scalar_exp: '(' scalar_exp ')'  */
                                   { (yyval.strval) = (yyvsp[-1].strval); }
    break;

  case 178: /* scalar_exp_commalist: scalar_exp  */
                {
		    (yyval.colNameList) = new ColumnNameList;
		    (yyval.colNameList)->push_back((yyvsp[0].strval));
	
		}
    break;

  case 179: /* scalar_exp_commalist: scalar_exp_commalist ',' scalar_exp  */
                { 
		    (yyval.colNameList) = (yyvsp[-2].colNameList);
		    (yyval.colNameList)->push_back((yyvsp[0].strval));
		}
    break;

  case 184: /* parameter_ref: parameter parameter  */
                {
		   std::string str = (yyvsp[-1].strval);
		   str += " ";
		   str += (yyvsp[0].strval);
		   (yyval.strval) = copy_string(str.c_str()); 	
		}
    break;

  case 185: /* parameter_ref: parameter INDICATOR parameter  */
                {
		   std::string str = (yyvsp[-2].strval);
		   str += " ";
		   str += (yyvsp[-1].strval);
		   str += " ";
		   str += (yyvsp[0].strval);
		   (yyval.strval) = copy_string(str.c_str());	
		}
    break;

  case 186: /* function_ref: AMMSC '(' '*' ')'  */
                {
		   std::string str = (yyvsp[-3].strval);
		   str += "(";
		   str +=  "*";
		   str +=  ")";
		   (yyval.strval) = copy_string(str.c_str());
  	    }
    break;

  case 187: /* function_ref: AMMSC '(' DISTINCT column_ref ')'  */
                {
		   std::string str = (yyvsp[-4].strval);
		   str += "(";
		   str += (yyvsp[-2].strval);
		   str += " ";
		   str += (yyvsp[-1].strval);
		   str += ")";
		   (yyval.strval) = copy_string(str.c_str());
		  			   
		}
    break;

  case 188: /* function_ref: AMMSC '(' ALL scalar_exp ')'  */
                {
		   std::string str = (yyvsp[-4].strval);
           str += "(";
           str += (yyvsp[-2].strval);
           str += " ";
           str += (yyvsp[-1].strval);
           str += ")";
           (yyval.strval) = copy_string(str.c_str());	
		}
    break;

  case 189: /* function_ref: AMMSC '(' scalar_exp ')'  */
                {
		   std::string str = (yyvsp[-3].strval);
		   str += "(";
		   str += (yyvsp[-1].strval);
		   str	+= ")";	
	       (yyval.strval) = copy_string(str.c_str());	 	
		}
    break;

  case 194: /* table_name: NAME '.' NAME  */
                      {(yyval.tblName) = new TableName((yyvsp[-2].strval), (yyvsp[0].strval));}
    break;

  case 195: /* table_name: NAME  */
               {
				if (default_schema.size())
					(yyval.tblName) = new TableName((char*)default_schema.c_str(), (yyvsp[0].strval));
				else
				    (yyval.tblName) = new TableName((yyvsp[0].strval));
		   }
    break;

  case 197: /* column_ref: NAME '.' NAME  */
                {
		   std::string str = (yyvsp[-2].strval);
		   str += ".";
		   str += (yyvsp[0].strval);	
		   (yyval.strval) = copy_string(str.c_str());
		}
    break;

  case 198: /* column_ref: NAME '.' NAME '.' NAME  */
                { 
		  std::string str = (yyvsp[-4].strval);
		  str += ".";
		  str += (yyvsp[-2].strval);
		  str += ".";
		  str += (yyvsp[0].strval);
		  (yyval.strval) = copy_string(str.c_str());	
		}
    break;

  case 218: /* sql: WHENEVER NOT FOUND when_action  */
                                               { (yyval.sqlStmt) = NULL; }
    break;

  case 219: /* sql: WHENEVER SQLERROR when_action  */
                                               { (yyval.sqlStmt) = NULL; }
    break;



      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (scanner, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, scanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, scanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (scanner, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, scanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, scanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}



using namespace dmlpackage;

namespace dmlpackage
{

void grammar_init(ParseTree *_parseTree, bool debug)
{
	parseTree = _parseTree;
	
	if(debug)
	  yydebug = 1;
}

void free_copybuffer()
{
  
   unsigned int i;
   for(i = 0; i < copy_buffer.size(); i++)
   {
      if (copy_buffer[i])
	      free(copy_buffer[i]);	    	
   }
   copy_buffer.clear();		  
}

char* copy_string(const char *str)
{
    char* nv = strdup(str);
    if (nv)
	   copy_buffer.push_back(nv);

    return nv;		
}

void set_defaultSchema(std::string schema)
{
    default_schema = schema;
}

}
